<script>
  // Cf https://schema.org/ServiceChannel
  export let identifier = null;
  export let name = null;
  export let serviceLocation = null; // CivicStructure
  export let providesService = null; // Service

  import PropertyValue from "./PropertyValue.svelte";
  import CivicStructure from "./CivicStructure.svelte";
  import { isPropertyValue } from "_src/schema_org.js";

  // Groups services by categories
  // categories and services are sorted along their identifiers
  function computeServiceGroups(providesService) {
    if (!providesService) {
      return [];
    }

    // Group services by category
    const categoryMap = new Map();
    for (const service of providesService) {
      const categoryId = service.category.identifier;
      if (!categoryMap.has(categoryId)) {
        categoryMap.set(categoryId, []);
      }
      categoryMap.get(categoryId).push(service);
    }

    // Sort categories by id
    const categoryList = [...categoryMap.keys()].sort((a, b) => a - b);

    return categoryList.map(categoryId => ({
      identifier: categoryId,
      name: categoryMap.get(categoryId)[0].category.name,
      services: categoryMap
        .get(categoryId)
        .sort((a, b) => a.identifier - b.identifier)
    }));
  }
</script>

<div>
  {#if name}
    <h1 class="mb-2">{name}</h1>
  {/if}
  {#if identifier}
    {#if isPropertyValue(identifier)}
      <PropertyValue {...identifier} />
    {:else}
      <div>{identifier}</div>
    {/if}
  {/if}
  {#if serviceLocation}
    <CivicStructure {...serviceLocation} />
  {/if}
  {#if providesService != null && providesService.length != 0}
    <h2>Services proposés</h2>
    {#each computeServiceGroups(providesService) as serviceGroup}
      <h3>{serviceGroup.name}</h3>
      <ul>
        {#each serviceGroup.services as service}
          <li>- {service.name}</li>
        {/each}
      </ul>
    {/each}
  {/if}
</div>
